Index: /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/SED/sedstp.F90
===================================================================
--- /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/SED/sedstp.F90	(revision 11948)
+++ /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/SED/sedstp.F90	(revision 11949)
@@ -29,5 +29,5 @@
 CONTAINS
 
-   SUBROUTINE sed_stp ( kt )
+   SUBROUTINE sed_stp ( kt, Kbb, Kmm, Krhs )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE sed_stp  ***
@@ -44,5 +44,6 @@
       !!        !  06-04 (C. Ethe)  Re-organization
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt       ! number of iteration
+      INTEGER, INTENT(in) ::   kt                ! number of iteration
+      INTEGER, INTENT(in) ::   Kbb, Kmm, Krhs    ! time level indices
       INTEGER :: ji,jk,js,jn,jw
       !!----------------------------------------------------------------------
@@ -52,10 +53,10 @@
       IF( lrst_sed )            CALL sed_rst_cal  ( kt, 'WRITE' )   ! calenda
 
-      IF(ln_sediment_offline)   CALL trc_dmp_sed  ( kt )
+      IF(ln_sediment_offline)   CALL trc_dmp_sed  ( kt, Kbb, Kmm, Krhs )
 
       dtsed  = r2dttrc
 !      dtsed2 = dtsed
       IF (kt /= nitsed000) THEN
-         CALL sed_dta( kt )       ! Load  Data for bot. wat. Chem and fluxes
+         CALL sed_dta( kt, Kbb, Kmm )       ! Load  Data for bot. wat. Chem and fluxes
       ENDIF
 
@@ -80,5 +81,5 @@
          CALL sed_mbc( kt )         ! cumulation for mass balance calculation
 
-         IF (ln_sed_2way) CALL sed_sfc( kt )         ! Give back new bottom wat chem to tracer model
+         IF (ln_sed_2way) CALL sed_sfc( kt, Kbb )         ! Give back new bottom wat chem to tracer model
       ENDIF
       CALL sed_wri( kt )         ! outputs
Index: /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/SED/trcdmp_sed.F90
===================================================================
--- /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/SED/trcdmp_sed.F90	(revision 11948)
+++ /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/SED/trcdmp_sed.F90	(revision 11949)
@@ -54,5 +54,5 @@
 
 
-   SUBROUTINE trc_dmp_sed( kt )
+   SUBROUTINE trc_dmp_sed( kt, Kbb, Kmm, Krhs )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE trc_dmp_sed  ***
@@ -64,14 +64,15 @@
       !! ** Method  :   Newtonian damping towards trdta computed 
       !!      and add to the general tracer trends:
-      !!                     trn = tra + restotr * (trdta - trb)
+      !!                     tr(Kmm) = tr(Krhs) + restotr * (trdta - tr(Kbb))
       !!         The trend is computed either throughout the water column
       !!      (nlmdmptr=0) or in area of weak vertical mixing (nlmdmptr=1) or
       !!      below the well mixed layer (nlmdmptr=2)
       !!
-      !! ** Action  : - update the tracer trends tra with the newtonian 
+      !! ** Action  : - update the tracer trends tr(Krhs) with the newtonian 
       !!                damping trends.
       !!              - save the trends ('key_trdmxl_trc')
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      INTEGER, INTENT(in) ::   kt              ! ocean time-step index
+      INTEGER, INTENT(in) ::   Kbb, Kmm, Krhs  ! time level index
       !
       INTEGER ::   ji, jj, jk, jn, jl, ikt   ! dummy loop indices
@@ -90,10 +91,10 @@
                !
                jl = n_trc_index(jn) 
-               CALL trc_dta( kt, sf_trcdta(jl), rf_trfac(jl), ztrcdta )   ! read tracer data at nit000
+               CALL trc_dta( kt, Kmm, sf_trcdta(jl), rf_trfac(jl), ztrcdta )   ! read tracer data at nit000
                !
                DO jj = 1, jpj
                   DO ji = 1, jpi   ! vector opt.
                      ikt = mbkt(ji,jj)
-                     trb(ji,jj,ikt,jn) = ztrcdta(ji,jj,ikt) + ( trb(ji,jj,ikt,jn) -  ztrcdta(ji,jj,ikt) )     &
+                     tr(ji,jj,ikt,jn,Kbb) = ztrcdta(ji,jj,ikt) + ( tr(ji,jj,ikt,jn,Kbb) -  ztrcdta(ji,jj,ikt) )     &
                      &                  * exp( -restosed(ji,jj,ikt) * dtsed )
                   END DO
@@ -109,5 +110,5 @@
          WRITE(charout, FMT="('dmp ')")
          CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+         CALL prt_ctl_trc( tab4d=tr(:,:,:,:,Krhs), mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       ENDIF
       !
@@ -148,6 +149,7 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE trc_dmp_sed( kt )        ! Empty routine
+   SUBROUTINE trc_dmp_sed( kt, Kbb, Kmm, Krhs )   ! Empty routine
       INTEGER, INTENT(in) :: kt
+      INTEGER, INTENT(in) :: Kbb, Kmm, Krhs
       WRITE(*,*) 'trc_dmp_sed: You should not have seen this print! error?', kt
    END SUBROUTINE trc_dmp_sed
Index: /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcini_pisces.F90
===================================================================
--- /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcini_pisces.F90	(revision 11948)
+++ /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcini_pisces.F90	(revision 11949)
@@ -32,5 +32,5 @@
 CONTAINS
 
-   SUBROUTINE trc_ini_pisces
+   SUBROUTINE trc_ini_pisces( Kmm )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE trc_ini_pisces ***
@@ -38,9 +38,10 @@
       !! ** Purpose :   Initialisation of the PISCES biochemical model
       !!----------------------------------------------------------------------
+      INTEGER, INTENT(in)  ::  Kmm      ! time level indices
       !
       CALL trc_nam_pisces
       !
-      IF( ln_p4z .OR. ln_p5z ) THEN  ;   CALL p4z_ini   !  PISCES
-      ELSE                           ;   CALL p2z_ini   !  LOBSTER
+      IF( ln_p4z .OR. ln_p5z ) THEN  ;   CALL p4z_ini( Kmm )   !  PISCES
+      ELSE                           ;   CALL p2z_ini( Kmm )   !  LOBSTER
       ENDIF
 
@@ -48,5 +49,5 @@
 
 
-   SUBROUTINE p4z_ini
+   SUBROUTINE p4z_ini( Kmm )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE p4z_ini ***
@@ -77,4 +78,5 @@
       USE p5zmort         !  Mortality terms for phytoplankton
       !
+      INTEGER, INTENT(in)  ::  Kmm      ! time level indices
       REAL(wp), SAVE ::   sco2   =  2.312e-3_wp
       REAL(wp), SAVE ::   alka0  =  2.426e-3_wp
@@ -189,47 +191,47 @@
       !--------------------------------------------------------------
       IF( .NOT.ln_rsttr ) THEN  
-         trn(:,:,:,jpdic) = sco2
-         trn(:,:,:,jpdoc) = bioma0
-         trn(:,:,:,jptal) = alka0
-         trn(:,:,:,jpoxy) = oxyg0
-         trn(:,:,:,jpcal) = bioma0
-         trn(:,:,:,jppo4) = po4 / po4r
-         trn(:,:,:,jppoc) = bioma0
-         trn(:,:,:,jpgoc) = bioma0
-         trn(:,:,:,jpbfe) = bioma0 * 5.e-6
-         trn(:,:,:,jpsil) = silic1
-         trn(:,:,:,jpdsi) = bioma0 * 0.15
-         trn(:,:,:,jpgsi) = bioma0 * 5.e-6
-         trn(:,:,:,jpphy) = bioma0
-         trn(:,:,:,jpdia) = bioma0
-         trn(:,:,:,jpzoo) = bioma0
-         trn(:,:,:,jpmes) = bioma0
-         trn(:,:,:,jpfer) = 0.6E-9
-         trn(:,:,:,jpsfe) = bioma0 * 5.e-6
-         trn(:,:,:,jpdfe) = bioma0 * 5.e-6
-         trn(:,:,:,jpnfe) = bioma0 * 5.e-6
-         trn(:,:,:,jpnch) = bioma0 * 12. / 55.
-         trn(:,:,:,jpdch) = bioma0 * 12. / 55.
-         trn(:,:,:,jpno3) = no3
-         trn(:,:,:,jpnh4) = bioma0
+         tr(:,:,:,jpdic,Kmm) = sco2
+         tr(:,:,:,jpdoc,Kmm) = bioma0
+         tr(:,:,:,jptal,Kmm) = alka0
+         tr(:,:,:,jpoxy,Kmm) = oxyg0
+         tr(:,:,:,jpcal,Kmm) = bioma0
+         tr(:,:,:,jppo4,Kmm) = po4 / po4r
+         tr(:,:,:,jppoc,Kmm) = bioma0
+         tr(:,:,:,jpgoc,Kmm) = bioma0
+         tr(:,:,:,jpbfe,Kmm) = bioma0 * 5.e-6
+         tr(:,:,:,jpsil,Kmm) = silic1
+         tr(:,:,:,jpdsi,Kmm) = bioma0 * 0.15
+         tr(:,:,:,jpgsi,Kmm) = bioma0 * 5.e-6
+         tr(:,:,:,jpphy,Kmm) = bioma0
+         tr(:,:,:,jpdia,Kmm) = bioma0
+         tr(:,:,:,jpzoo,Kmm) = bioma0
+         tr(:,:,:,jpmes,Kmm) = bioma0
+         tr(:,:,:,jpfer,Kmm) = 0.6E-9
+         tr(:,:,:,jpsfe,Kmm) = bioma0 * 5.e-6
+         tr(:,:,:,jpdfe,Kmm) = bioma0 * 5.e-6
+         tr(:,:,:,jpnfe,Kmm) = bioma0 * 5.e-6
+         tr(:,:,:,jpnch,Kmm) = bioma0 * 12. / 55.
+         tr(:,:,:,jpdch,Kmm) = bioma0 * 12. / 55.
+         tr(:,:,:,jpno3,Kmm) = no3
+         tr(:,:,:,jpnh4,Kmm) = bioma0
          IF( ln_ligand) THEN
-            trn(:,:,:,jplgw) = 0.6E-9
+            tr(:,:,:,jplgw,Kmm) = 0.6E-9
          ENDIF
          IF( ln_p5z ) THEN
-            trn(:,:,:,jpdon) = bioma0
-            trn(:,:,:,jpdop) = bioma0
-            trn(:,:,:,jppon) = bioma0
-            trn(:,:,:,jppop) = bioma0
-            trn(:,:,:,jpgon) = bioma0
-            trn(:,:,:,jpgop) = bioma0
-            trn(:,:,:,jpnph) = bioma0
-            trn(:,:,:,jppph) = bioma0
-            trn(:,:,:,jppic) = bioma0
-            trn(:,:,:,jpnpi) = bioma0
-            trn(:,:,:,jpppi) = bioma0
-            trn(:,:,:,jpndi) = bioma0
-            trn(:,:,:,jppdi) = bioma0
-            trn(:,:,:,jppfe) = bioma0 * 5.e-6
-            trn(:,:,:,jppch) = bioma0 * 12. / 55.
+            tr(:,:,:,jpdon,Kmm) = bioma0
+            tr(:,:,:,jpdop,Kmm) = bioma0
+            tr(:,:,:,jppon,Kmm) = bioma0
+            tr(:,:,:,jppop,Kmm) = bioma0
+            tr(:,:,:,jpgon,Kmm) = bioma0
+            tr(:,:,:,jpgop,Kmm) = bioma0
+            tr(:,:,:,jpnph,Kmm) = bioma0
+            tr(:,:,:,jppph,Kmm) = bioma0
+            tr(:,:,:,jppic,Kmm) = bioma0
+            tr(:,:,:,jpnpi,Kmm) = bioma0
+            tr(:,:,:,jpppi,Kmm) = bioma0
+            tr(:,:,:,jpndi,Kmm) = bioma0
+            tr(:,:,:,jppdi,Kmm) = bioma0
+            tr(:,:,:,jppfe,Kmm) = bioma0 * 5.e-6
+            tr(:,:,:,jppch,Kmm) = bioma0 * 12. / 55.
          ENDIF
          ! initialize the half saturation constant for silicate
@@ -254,5 +256,5 @@
          CALL p5z_prod_init      !  phytoplankton growth rate over the global ocean.
       ENDIF
-      CALL p4z_sbc_init          !  boundary conditions
+      CALL p4z_sbc_init( Kmm )   !  boundary conditions
       CALL p4z_fechem_init       !  Iron chemistry
       CALL p4z_rem_init          !  remineralisation
@@ -284,5 +286,5 @@
 
 
-   SUBROUTINE p2z_ini
+   SUBROUTINE p2z_ini( Kmm )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE p2z_ini ***
@@ -296,4 +298,5 @@
       USE p2zsed
       !
+      INTEGER, INTENT(in)  ::  Kmm      ! time level indices
       INTEGER  ::  ji, jj, jk, jn, ierr
       CHARACTER(len = 10)  ::  cltra
@@ -334,18 +337,18 @@
       ! ----------------------
       IF( .NOT. ln_rsttr ) THEN             ! in case of  no restart 
-         trn(:,:,:,jpdet) = 0.1 * tmask(:,:,:)
-         trn(:,:,:,jpzoo) = 0.1 * tmask(:,:,:)
-         trn(:,:,:,jpnh4) = 0.1 * tmask(:,:,:)
-         trn(:,:,:,jpphy) = 0.1 * tmask(:,:,:)
-         trn(:,:,:,jpdom) = 1.0 * tmask(:,:,:)
-         WHERE( rhd(:,:,:) <= 24.5e-3 )  ;  trn(:,:,:,jpno3) = 2._wp * tmask(:,:,:)
-         ELSE WHERE                      ;  trn(:,:,:,jpno3) = ( 15.55 * ( rhd(:,:,:) * 1000. ) - 380.11 ) * tmask(:,:,:)
+         tr(:,:,:,jpdet,Kmm) = 0.1 * tmask(:,:,:)
+         tr(:,:,:,jpzoo,Kmm) = 0.1 * tmask(:,:,:)
+         tr(:,:,:,jpnh4,Kmm) = 0.1 * tmask(:,:,:)
+         tr(:,:,:,jpphy,Kmm) = 0.1 * tmask(:,:,:)
+         tr(:,:,:,jpdom,Kmm) = 1.0 * tmask(:,:,:)
+         WHERE( rhd(:,:,:) <= 24.5e-3 )  ;  tr(:,:,:,jpno3,Kmm) = 2._wp * tmask(:,:,:)
+         ELSE WHERE                      ;  tr(:,:,:,jpno3,Kmm) = ( 15.55 * ( rhd(:,:,:) * 1000. ) - 380.11 ) * tmask(:,:,:)
          END WHERE                       
       ENDIF
-      !                       !  Namelist read
-      CALL p2z_opt_init       !  Optics parameters
-      CALL p2z_sed_init       !  sedimentation
-      CALL p2z_bio_init       !  biology
-      CALL p2z_exp_init       !  export 
+      !                        !  Namelist read
+      CALL p2z_opt_init        !  Optics parameters
+      CALL p2z_sed_init        !  sedimentation
+      CALL p2z_bio_init        !  biology
+      CALL p2z_exp_init( Kmm ) !  export 
       !
       IF(lwp) WRITE(numout,*) 
Index: /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcsms_pisces.F90
===================================================================
--- /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcsms_pisces.F90	(revision 11948)
+++ /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcsms_pisces.F90	(revision 11949)
@@ -25,5 +25,5 @@
 CONTAINS
 
-   SUBROUTINE trc_sms_pisces( kt )
+   SUBROUTINE trc_sms_pisces( kt, Kbb, Kmm, Krhs )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE trc_sms_pisces  ***
@@ -34,9 +34,10 @@
       !!---------------------------------------------------------------------
       !
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
+      INTEGER, INTENT( in ) ::   kt               ! ocean time-step index      
+      INTEGER, INTENT( in ) ::   Kbb, Kmm, Krhs   ! time level index
       !!---------------------------------------------------------------------
       !
-      IF( ln_p4z .OR. ln_p5z ) THEN  ;   CALL p4z_sms( kt )   !  PISCES
-      ELSE                           ;   CALL p2z_sms( kt )   !  LOBSTER
+      IF( ln_p4z .OR. ln_p5z ) THEN  ;   CALL p4z_sms( kt, Kbb, Kmm, Krhs )   !  PISCES
+      ELSE                           ;   CALL p2z_sms( kt,      Kmm, Krhs )   !  LOBSTER
       ENDIF
 
Index: /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcwri_pisces.F90
===================================================================
--- /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcwri_pisces.F90	(revision 11948)
+++ /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/PISCES/trcwri_pisces.F90	(revision 11949)
@@ -26,5 +26,5 @@
 CONTAINS
 
-   SUBROUTINE trc_wri_pisces
+   SUBROUTINE trc_wri_pisces( Kmm )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE trc_wri_trc  ***
@@ -32,4 +32,5 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
+      INTEGER, INTENT(in)          :: Kmm      ! time level indices
       CHARACTER (len=20)           :: cltra
       REAL(wp)                     :: zfact
@@ -43,5 +44,5 @@
          DO jn = jp_pcs0, jp_pcs1
             cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
-            CALL iom_put( cltra, trn(:,:,:,jn) )
+            CALL iom_put( cltra, tr(:,:,:,jn,Kmm) )
          END DO
       ELSE
@@ -51,5 +52,5 @@
             IF( jn == jppo4  )                 zfact = po4r * 1.0e+6
             cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
-            IF( iom_use( cltra ) )  CALL iom_put( cltra, trn(:,:,:,jn) * zfact )
+            IF( iom_use( cltra ) )  CALL iom_put( cltra, tr(:,:,:,jn,Kmm) * zfact )
          END DO
 
@@ -57,5 +58,5 @@
             zdic(:,:) = 0.
             DO jk = 1, jpkm1
-               zdic(:,:) = zdic(:,:) + trn(:,:,jk,jpdic) * e3t_n(:,:,jk) * tmask(:,:,jk) * 12.
+               zdic(:,:) = zdic(:,:) + tr(:,:,jk,jpdic,Kmm) * e3t(:,:,jk,Kmm) * tmask(:,:,jk) * 12.
             ENDDO
             CALL iom_put( 'INTDIC', zdic )     
@@ -63,13 +64,13 @@
          !
          IF( iom_use( "O2MIN" ) .OR. iom_use ( "ZO2MIN" ) ) THEN  ! Oxygen minimum concentration and depth 
-            zo2min   (:,:) = trn(:,:,1,jpoxy) * tmask(:,:,1)
-            zdepo2min(:,:) = gdepw_n(:,:,1)   * tmask(:,:,1)
+            zo2min   (:,:) = tr(:,:,1,jpoxy,Kmm) * tmask(:,:,1)
+            zdepo2min(:,:) = gdepw(:,:,1,Kmm)   * tmask(:,:,1)
             DO jk = 2, jpkm1
                DO jj = 1, jpj
                   DO ji = 1, jpi
                      IF( tmask(ji,jj,jk) == 1 ) then
-                        IF( trn(ji,jj,jk,jpoxy) < zo2min(ji,jj) ) then
-                           zo2min   (ji,jj) = trn(ji,jj,jk,jpoxy)
-                           zdepo2min(ji,jj) = gdepw_n(ji,jj,jk)
+                        IF( tr(ji,jj,jk,jpoxy,Kmm) < zo2min(ji,jj) ) then
+                           zo2min   (ji,jj) = tr(ji,jj,jk,jpoxy,Kmm)
+                           zdepo2min(ji,jj) = gdepw(ji,jj,jk,Kmm)
                         ENDIF
                      ENDIF
Index: /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/TRP/trcadv.F90
===================================================================
--- /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/TRP/trcadv.F90	(revision 11948)
+++ /NEMO/branches/2019/dev_r11943_MERGE_2019/src/TOP/TRP/trcadv.F90	(revision 11949)
@@ -68,5 +68,5 @@
 CONTAINS
 
-   SUBROUTINE trc_adv( kt )
+   SUBROUTINE trc_adv( kt, Kbb, Kmm, ptr, Krhs  )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trc_adv  ***
@@ -74,11 +74,13 @@
       !! ** Purpose :   compute the ocean tracer advection trend.
       !!
-      !! ** Method  : - Update after tracers (tra) with the advection term following nadv
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !! ** Method  : - Update after tracers (tr(Krhs)) with the advection term following nadv
+      !!----------------------------------------------------------------------
+      INTEGER                                   , INTENT(in)    :: kt   ! ocean time-step index
+      INTEGER                                   , INTENT(in)    :: Kbb, Kmm, Krhs ! time level indices
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jptra,jpt), INTENT(inout) :: ptr            ! passive tracers and RHS of tracer equation
       !
       INTEGER ::   jk   ! dummy loop index
       CHARACTER (len=22) ::   charout
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zun, zvn, zwn  ! effective velocity
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zuu, zvv, zww  ! effective velocity
       !!----------------------------------------------------------------------
       !
@@ -87,34 +89,34 @@
       !                                         !==  effective transport  ==!
       IF( l_offline ) THEN
-         zun(:,:,:) = un(:,:,:)                    ! already in (un,vn,wn)
-         zvn(:,:,:) = vn(:,:,:)
-         zwn(:,:,:) = wn(:,:,:)
+         zuu(:,:,:) = uu(:,:,:,Kmm)                ! already in (uu(Kmm),vv(Kmm),ww)
+         zvv(:,:,:) = vv(:,:,:,Kmm)
+         zww(:,:,:) = ww(:,:,:)
       ELSE                                         ! build the effective transport
-         zun(:,:,jpk) = 0._wp
-         zvn(:,:,jpk) = 0._wp
-         zwn(:,:,jpk) = 0._wp
+         zuu(:,:,jpk) = 0._wp
+         zvv(:,:,jpk) = 0._wp
+         zww(:,:,jpk) = 0._wp
          IF( ln_wave .AND. ln_sdw )  THEN
             DO jk = 1, jpkm1                                                       ! eulerian transport + Stokes Drift
-               zun(:,:,jk) = e2u  (:,:) * e3u_n(:,:,jk) * ( un(:,:,jk) + usd(:,:,jk) )
-               zvn(:,:,jk) = e1v  (:,:) * e3v_n(:,:,jk) * ( vn(:,:,jk) + vsd(:,:,jk) )
-               zwn(:,:,jk) = e1e2t(:,:)                 * ( wn(:,:,jk) + wsd(:,:,jk) )
+               zuu(:,:,jk) = e2u  (:,:) * e3u(:,:,jk,Kmm) * ( uu(:,:,jk,Kmm) + usd(:,:,jk) )
+               zvv(:,:,jk) = e1v  (:,:) * e3v(:,:,jk,Kmm) * ( vv(:,:,jk,Kmm) + vsd(:,:,jk) )
+               zww(:,:,jk) = e1e2t(:,:)                   * ( ww(:,:,jk) + wsd(:,:,jk) )
             END DO
          ELSE
             DO jk = 1, jpkm1
-               zun(:,:,jk) = e2u  (:,:) * e3u_n(:,:,jk) * un(:,:,jk)                   ! eulerian transport
-               zvn(:,:,jk) = e1v  (:,:) * e3v_n(:,:,jk) * vn(:,:,jk)
-               zwn(:,:,jk) = e1e2t(:,:)                 * wn(:,:,jk)
+               zuu(:,:,jk) = e2u  (:,:) * e3u(:,:,jk,Kmm) * uu(:,:,jk,Kmm)                   ! eulerian transport
+               zvv(:,:,jk) = e1v  (:,:) * e3v(:,:,jk,Kmm) * vv(:,:,jk,Kmm)
+               zww(:,:,jk) = e1e2t(:,:)                   * ww(:,:,jk)
             END DO
          ENDIF
          !
          IF( ln_vvl_ztilde .OR. ln_vvl_layer ) THEN                                 ! add z-tilde and/or vvl corrections
-            zun(:,:,:) = zun(:,:,:) + un_td(:,:,:)
-            zvn(:,:,:) = zvn(:,:,:) + vn_td(:,:,:)
+            zuu(:,:,:) = zuu(:,:,:) + un_td(:,:,:)
+            zvv(:,:,:) = zvv(:,:,:) + vn_td(:,:,:)
          ENDIF
          !
          IF( ln_ldfeiv .AND. .NOT. ln_traldf_triad )   & 
-            &              CALL ldf_eiv_trp( kt, nittrc000, zun, zvn, zwn, 'TRC' )  ! add the eiv transport
-         !
-         IF( ln_mle    )   CALL tra_mle_trp( kt, nittrc000, zun, zvn, zwn, 'TRC' )  ! add the mle transport
+            &              CALL ldf_eiv_trp( kt, nittrc000, zuu, zvv, zww, 'TRC', Kmm, Krhs )  ! add the eiv transport
+         !
+         IF( ln_mle    )   CALL tra_mle_trp( kt, nittrc000, zuu, zvv, zww, 'TRC', Kmm       )  ! add the mle transport
          !
       ENDIF
@@ -123,13 +125,13 @@
       !
       CASE ( np_CEN )                                 ! Centered : 2nd / 4th order
-         CALL tra_adv_cen( kt, nittrc000,'TRC',          zun, zvn, zwn     , trn, tra, jptra, nn_cen_h, nn_cen_v )
+         CALL tra_adv_cen( kt, nittrc000,'TRC',          zuu, zvv, zww,      Kmm, ptr, jptra, Krhs, nn_cen_h, nn_cen_v )
       CASE ( np_FCT )                                 ! FCT      : 2nd / 4th order
-         CALL tra_adv_fct( kt, nittrc000,'TRC', r2dttrc, zun, zvn, zwn, trb, trn, tra, jptra, nn_fct_h, nn_fct_v )
+         CALL tra_adv_fct( kt, nittrc000,'TRC', r2dttrc, zuu, zvv, zww, Kbb, Kmm, ptr, jptra, Krhs, nn_fct_h, nn_fct_v )
       CASE ( np_MUS )                                 ! MUSCL
-         CALL tra_adv_mus( kt, nittrc000,'TRC', r2dttrc, zun, zvn, zwn, trb,      tra, jptra        , ln_mus_ups ) 
+         CALL tra_adv_mus( kt, nittrc000,'TRC', r2dttrc, zuu, zvv, zww, Kbb, Kmm, ptr, jptra, Krhs, ln_mus_ups         ) 
       CASE ( np_UBS )                                 ! UBS
-         CALL tra_adv_ubs( kt, nittrc000,'TRC', r2dttrc, zun, zvn, zwn, trb, trn, tra, jptra          , nn_ubs_v )
+         CALL tra_adv_ubs( kt, nittrc000,'TRC', r2dttrc, zuu, zvv, zww, Kbb, Kmm, ptr, jptra, Krhs, nn_ubs_v           )
       CASE ( np_QCK )                                 ! QUICKEST
-         CALL tra_adv_qck( kt, nittrc000,'TRC', r2dttrc, zun, zvn, zwn, trb, trn, tra, jptra                     )
+         CALL tra_adv_qck( kt, nittrc000,'TRC', r2dttrc, zuu, zvv, zww, Kbb, Kmm, ptr, jptra, Krhs                     )
       !
       END SELECT
@@ -138,5 +140,5 @@
          WRITE(charout, FMT="('adv ')")
          CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+         CALL prt_ctl_trc( tab4d=tr(:,:,:,:,Krhs), mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       END IF
       !
